/**
 */
package de.cau.cs.kieler.tutorials.klighd.turingmachine;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Transition</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getSourceState <em>Source State</em>}</li>
 *   <li>{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getTargetState <em>Target State</em>}</li>
 *   <li>{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getTrigger <em>Trigger</em>}</li>
 *   <li>{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getAction <em>Action</em>}</li>
 *   <li>{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getDirection <em>Direction</em>}</li>
 *   <li>{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getNewChar <em>New Char</em>}</li>
 * </ul>
 *
 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.TuringmachinePackage#getTransition()
 * @model
 * @generated
 */
public interface Transition extends EObject {
	/**
	 * Returns the value of the '<em><b>Source State</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.State#getOutgoingTransitions <em>Outgoing Transitions</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source State</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source State</em>' container reference.
	 * @see #setSourceState(State)
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.TuringmachinePackage#getTransition_SourceState()
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.State#getOutgoingTransitions
	 * @model opposite="outgoingTransitions" required="true" transient="false"
	 * @generated
	 */
	State getSourceState();

	/**
	 * Sets the value of the '{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getSourceState <em>Source State</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source State</em>' container reference.
	 * @see #getSourceState()
	 * @generated
	 */
	void setSourceState(State value);

	/**
	 * Returns the value of the '<em><b>Target State</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.State#getIncomingTransitions <em>Incoming Transitions</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target State</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target State</em>' reference.
	 * @see #setTargetState(State)
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.TuringmachinePackage#getTransition_TargetState()
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.State#getIncomingTransitions
	 * @model opposite="incomingTransitions" required="true"
	 * @generated
	 */
	State getTargetState();

	/**
	 * Sets the value of the '{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getTargetState <em>Target State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target State</em>' reference.
	 * @see #getTargetState()
	 * @generated
	 */
	void setTargetState(State value);

	/**
	 * Returns the value of the '<em><b>Trigger</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trigger</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Trigger</em>' attribute.
	 * @see #setTrigger(String)
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.TuringmachinePackage#getTransition_Trigger()
	 * @model default="0" required="true"
	 * @generated
	 */
	String getTrigger();

	/**
	 * Sets the value of the '{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getTrigger <em>Trigger</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Trigger</em>' attribute.
	 * @see #getTrigger()
	 * @generated
	 */
	void setTrigger(String value);

	/**
	 * Returns the value of the '<em><b>Action</b></em>' attribute.
	 * The literals are from the enumeration {@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Action}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Action</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Action</em>' attribute.
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.Action
	 * @see #setAction(Action)
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.TuringmachinePackage#getTransition_Action()
	 * @model required="true"
	 * @generated
	 */
	Action getAction();

	/**
	 * Sets the value of the '{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getAction <em>Action</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Action</em>' attribute.
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.Action
	 * @see #getAction()
	 * @generated
	 */
	void setAction(Action value);

	/**
	 * Returns the value of the '<em><b>Direction</b></em>' attribute.
	 * The default value is <code>"LEFT"</code>.
	 * The literals are from the enumeration {@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Direction}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Direction</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Direction</em>' attribute.
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.Direction
	 * @see #setDirection(Direction)
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.TuringmachinePackage#getTransition_Direction()
	 * @model default="LEFT" required="true"
	 * @generated
	 */
	Direction getDirection();

	/**
	 * Sets the value of the '{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getDirection <em>Direction</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Direction</em>' attribute.
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.Direction
	 * @see #getDirection()
	 * @generated
	 */
	void setDirection(Direction value);

	/**
	 * Returns the value of the '<em><b>New Char</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>New Char</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>New Char</em>' attribute.
	 * @see #setNewChar(String)
	 * @see de.cau.cs.kieler.tutorials.klighd.turingmachine.TuringmachinePackage#getTransition_NewChar()
	 * @model default="0"
	 * @generated
	 */
	String getNewChar();

	/**
	 * Sets the value of the '{@link de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition#getNewChar <em>New Char</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>New Char</em>' attribute.
	 * @see #getNewChar()
	 * @generated
	 */
	void setNewChar(String value);

} // Transition
